<template>
  <div id="teacher_lecture_index_wrapper" class="bt-container" :key="refreshCount">
    <h2 class="page-title">
      {{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : "" }}
    </h2>
    <div class="right-align-margin-bottom-15">
      <!-- <el-button
        @click="onClick('ANALYSIS')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("CLASS_MENU.JOURNALING") }}</el-button
      >
      <el-button
        @click="onClick('Q&A')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("CLASS_MENU.BOARD") }}</el-button
      >
      <el-button
        @click="onClick('ATTEND')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("CLASS_MENU.ATTEND_MANAGE") }}</el-button
      >
      <el-button
        @click="onClick('REPORT')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("CLASS_MENU.SCORE_MANAGE") }}</el-button
      >
      <el-button
        @click="onClick('NNGRADING')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("CLASS_MENU.GRADING_MANAGE") }}</el-button
      >
      <el-button
        @click="onClick('BACK')"
        :class="$attachReactablePostfix('el-btn')"
        >{{ $t("ITEM_FROM_BANK.BACK") }}</el-button
      > -->
      
      <!-- 실습수업 YES, 도커생성 YES, 도커상태 ON -->
      <el-button v-if="isPractice && dockercreated && dockerstatus" type="primary" style="font-weight: bold" @click="onClick('DOCKERON')"> 
        실습 OPEN
      </el-button>
      <!-- 실습수업 YES, 도커생성 YES, 도커상태 OFF -->
      <el-button v-else-if="isPractice && dockercreated && !dockerstatus" type="danger" @click="onClick('DOCKEROFF')">
        실습 CLOSED
      </el-button>      
      <!-- 실습수업 YES, 도커생성 YES, 도커상태 상관 없음 -->
      <el-button v-if="isPractice && dockercreated" type="danger" @click="onClick('DOCKERDEL')">
        Jupyter 삭제
      </el-button>
      <!-- 실습수업 YES, 도커생성 NO, 도커상태 상관 없음 -->
      <el-button v-if="isPractice && !dockercreated" type="primary" @click="onClick('DOCKERCREATE')">
        Jupyter 생성
      </el-button>

      <router-link :to="`/a/teacher/NNlecture/new?classId=${classId}`">
        <el-button :class="$attachReactablePostfix('el-btn')">{{
          $t("LECTURE_LIST.ADD_LECTURE")
        }}</el-button>
      </router-link>
      <router-link :to="`/a/teacher/NNlecture/newfrombank?classId=${classId}`">
        <el-button :class="$attachReactablePostfix('el-btn')">{{
          $t("LECTURE_LIST.LECTURE_FROM_BANK")
        }}</el-button>
      </router-link>
    </div>
    <div v-if="!loading">
      <i class="el-icon-loading" style="font-size: 50px; float: left"></i>
    </div>
    <lecture-list
      @row-click="onClickLecture"
      @delete="onClickDelete"
      @activaite="onClickActivaite"
      @tableColumnColor="tableColumnColor"
      @up="upLecture"
      @down="downLecture"
      ref="lectureLists"
      type="TEACHER"
      v-if="showLectureList"
      :list="newLectureList"
      :isPhone="$isPhone"
      :connectFlag="flag"
      :sortableOptions="sortableOptions"
    />

    <br />

    <!-- <div class="center-align">
      <router-link :to="`/a/teacher/NNlecture/new?classId=${classId}`">
        <el-button
          type="primary"
          :class="$attachReactablePostfix('right-align-btn')"
          style="width: 49%"
        >
          <div class="right-align-btn-layer">
            {{ $t("LECTURE_LIST.ADD_LECTURE") }}
          </div>
        </el-button>
      </router-link>
      <router-link :to="`/a/teacher/NNlecture/newfrombank?classId=${classId}`">
        <el-button
          type="primary"
          :class="$attachReactablePostfix('right-align-btn')"
          style="width: 49%"
        >
          <div class="right-align-btn-layer">
            {{ $t("LECTURE_LIST.LECTURE_FROM_BANK") }}
          </div>
        </el-button>
      </router-link>
    </div> -->
    <el-dialog
      :title="$t('LECTURE_LIST.EXCEPTION')"
      :visible.sync="exceptionDialogVisible"
      width="60%"
      :before-close="handleClose"
    >
      <h3>{{ $t("TEACHER_CLASS.LONG_EMAIL") }}</h3>
      <h3>{{ $t("TEACHER_CLASS.EXCEPT_STD") }}</h3>
      <el-table :data="exceptList">
        <el-table-column :label="$t('REG.EMAIL_LABEL')">
          <template slot-scope="scope">
            {{ scope.row.email }}
          </template>
        </el-table-column>
        <el-table-column :label="$t('REG.NAME_LABEL')" width="100px;">
          <template slot-scope="scope">
            {{ scope.row.name }}
          </template>
        </el-table-column>
      </el-table>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleClose">{{
          $t("NOTE.CONFIRM")
        }}</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
// TODO : 180629 - 기존 Q&A 가 '게시판' 으로 바꼈습니다. 모든 변수, 파일명의 Q&A를 board로 바꿀지..?
import Sortable from "sortablejs";
import deepCopy from "deep-copy";
import { mapState, mapActions, mapGetters } from "vuex";
import LectureList from "../partials/LectureList";
import utils from "../../utils";
import lectureService from "../../services/lectureService";
import authService from "../../services/authService";
import userService from "../../services/userService";
import classService from "../../services/classService";

// * 드래그 앤 드롭으로 테이블 행 순서 변경
// * https://buefy.github.io/#/extensions/sortablejs
// * TODO: 강의 순서에 대한 변수 생성(at backend) 후, start_time을 순서 변수로 변경
const createSortable = (el, options, vnode) => {
  //eslint-disable-line
  let sequence = []; //eslint-disable-line
  return Sortable.create(el, {
    ...options,
    onStart() {
      // when the sort starts, store the initial order of the array
      sequence = this.toArray(); //eslint-disable-line
    },
    onEnd(evt) {
      // when the sort ends, set the order to the initial state
      this.sort(sequence); //eslint-disable-line
      // change the order using splice
      const data = vnode.context.lectureList;
      data.splice(evt.newIndex, 0, ...data.splice(evt.oldIndex, 1));
    },
  });
};

/**
 * We add a new instance of Sortable when the element
 * is bound or updated, and destroy it when it's unbound.
 */
const sortable = {
  name: "sortable",
  bind(el, binding, vnode) {
    const table = el.querySelector(".el-table__body-wrapper");
    table._sortable = createSortable(table.querySelector("tbody"), binding.value, vnode); //eslint-disable-line
  },
  update(el, binding, vnode) {
    const table = el.querySelector(".el-table__body-wrapper");
    table._sortable.destroy(); //eslint-disable-line
    table._sortable = createSortable(table.querySelector("tbody"), binding.value, vnode); //eslint-disable-line
  },
  unbind(el) {
    const table = el.querySelector(".el-table__body-wrapper");
    table._sortable.destroy(); //eslint-disable-line
  },
};

export default {
  name: "TeacherLectureIndex",
  directives: { sortable },
  async created() {
    const vm = this;
    
    
    // 학생이 url로 접근하는 경우 방지
    const accessId = utils.getUserIdFromJwt();
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push("/");
    }
  },
  components: {
    LectureList,
  },
  data() {
    return {
      sortableOptions: {
        onUpdate: async (event) => {
          const vm = this;
          const oldSequence = event.oldIndex;
          const newSequence = event.newIndex;          
          const newLectureList = [];
          newLectureList[newSequence] = vm.lectureList[oldSequence];
          if (oldSequence < newSequence) {
            vm.lectureList.forEach((lecture, index) => {
              if (index > oldSequence && index <= newSequence) {
                newLectureList[index - 1] = vm.lectureList[index];
              }
            });
          } else {
            vm.lectureList.forEach((lecture, index) => {
              if (index >= newSequence && index < oldSequence) {
                newLectureList[index + 1] = vm.lectureList[index];
              }
            });
          }
          vm.refreshLectureList(newLectureList);
          newLectureList.forEach(async (lecture, index) => {
            await lectureService.putLecture({
              lecture_id: lecture.lecture_id,
              sequence: index,
            });
          });
        },
      },
      exceptionDialogVisible: false,
      exceptList: [],
      refreshCount: 0,
      loading: false,
      flag: false,
      showLectureList: false,
      newLectureList: null,
      // 실습 수업여부 체크
      isPractice: false,
      // 2021-03-18 도커 ON/OFF 상태 체크용 (default true)
      dockerstatus: true,      
      // 2021-03-31 도커가 생성되어있는지 상태 체크 (default true)
      dockercreated: true, 
    };
  },
  async mounted() {
    const vm = this;
    await vm.getMyClassLists();
    // FIXME: vm.getClass가 불릴 때 classStore.state.teachingClassList가
    // 아직 채워지지 않은 경우가 있음
    // 그래서 그냥 불렀는데. 구조적으로 개선이 필요함
    // 지금 꽤나 여러군데에서 getMyClassLists를 부르고 있다는 것이.. 좀..
    await vm.getClass({
      type: "TEACHER",
      classId: vm.classId,
    });
    vm.addTableEventListener();
    vm.loading = true;

    const lectureStudentNumber = [];

    // vm.sockets.subscribe('LECTURE_STUDENT_NUMBER', (msg) => {
    //   const jsonMSG = JSON.parse(msg);
    //   const target = lectureStudentNumber.filter(a => a.lecture_id === jsonMSG.lecture_id)[0];
    //   if (target !== undefined) {
    //     target.student_number = jsonMSG.student_number;
    //     target.status = 1;
    //   }
    // });

    // vm.lectureList.forEach(async (list) => {
    //   await lectureStudentNumber.push({
    //     lecture_id: list.lecture_id,
    //     status: 0,
    //     student_number: 0,
    //   });
    //   vm.$socket.emit('GET_LECTURE_STUDENT_NUBMER', JSON.stringify({
    //     lecture_id: list.lecture_id
    //   }));
    // });

    // x.cur_student = lectureService.getLecStudentCount({ lectureId: x.lecture_id });
    // x.cur_student.then((value) => {x.cur_student = value.data.count});
    // await new Promise((resolve) => {
    //   const interval = setInterval(() => {
    //     if (!lectureStudentNumber.find(list => list.status === 0)) {
    //       clearInterval(interval);
    //       resolve(true);
    //     }
    //   }, 100);
    // });
    vm.newLectureList = vm.lectureList.map((list) => ({
      ...list,
      // student_number: lectureStudentNumber.find(lecture => lecture.lecture_id === list.lecture_id).student_number
    }));

    // [회의방]의 room_id를 가져와서 newLectureList에 추가
    (await Promise.all(vm.newLectureList.map(nll => lectureService.getSmallRoomId({
      lectureId: nll.lecture_id
    })))).map(result => result.data.result ? result.data.result[0] : undefined).forEach((result, index) => {
      if (result) {
        vm.newLectureList[index].room_id = result.room_id;
      }
    });

    vm.showLectureList = true;

  },
  computed: {
    ...mapState("NNclass", ["teachingClassList"]),
    ...mapGetters("NNclass", ["currentTeachingClass"]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    lectureList() {
      const vm = this;
      if (!vm.teachingClassList) {
        return [];
      }
      const currentClass = vm.currentTeachingClass(vm.classId);

      // 2021-03-23 실습 수업인지 체크
      if (currentClass.practice === 1)
      {
        vm.isPractice = true;
      }
      
      // portNum이 1000일 경우 도커생성 YES, 도커상태 DOWN
      if (currentClass.portNum === 1000)
      {
        vm.dockercreated = true;
        vm.dockerstatus = false;
      }
      // portNum이 0 일 경우 도커생성 NO, 도커상태 DOWN
      if (currentClass.portNum === 0){        
        vm.dockercreated = false;
        vm.dockerstatus = false;
      }

      if (currentClass && Array.isArray(currentClass.lectures)) {
        const lectureList = currentClass.lectures.map((x) => {
          if (!isNaN(x.type)) {
            // 숫자 일때만 convert
            // eslint-disable-next-line no-param-reassign
            x.type = utils.convertLcType(x.type);
          }
          // eslint-disable-next-line no-param-reassign
          x.수강한학생수 = "0"; // TODO 변수명 변경, 값 할당
          // eslint-disable-next-line no-param-reassign
          x.capacity = vm.currentTeachingClass(vm.classId).users.length;
          // eslint-disable-next-line no-param-reassign
          x.수강생이해도 = "0"; // TODO 변수명 변경, 값 할당
          x.valid = false;
          currentClass.connect_sessions.forEach((y) => {
            if (y.source === x.lecture_id) {
              x.valid = true;
              vm.flag = true;
            }
          });
          return x;
        });
        if (lectureList.length) {
          vm.addTableEventListener();
        }
        // * sequence 순서대로 강의 정렬
        lectureList
          .map((item) => {
            item.sequence = Number(item.sequence);
            return item;
          })
          .sort((a, b) => {
            return a.sequence - b.sequence;
          });
        return lectureList;
      }
      /* if (currentClass && currentClass.lectures) {
        return currentClass.lectures.map((item) => {
          const type = utils.convertLcType(item.type);
          // eslint-disable-next-line no-param-reassign
          item.type = type;
          // eslint-disable-next-line no-param-reassign
          item.수강한학생수 = '0'; // TODO 변수명 변경, 값 할당
          // eslint-disable-next-line no-param-reassign
          item.capacity = vm.currentTeachingClass(vm.classId).capacity;
          // eslint-disable-next-line no-param-reassign
          item.수강생이해도 = '0'; // TODO 변수명 변경, 값 할당
          // sequence에 따른 순서 변경
          currentClass.lectures.sort((a, b) => {
          const aItemSequence = Number(a.sequence);
          const bItemSequence = Number(b.sequence);
          return aItemSequence - bItemSequence;
        });
          return item;
        });
      } */
      return [];
    },
  },
  methods: {
    ...mapActions("NNclass", ["getClass", "getMyClassLists", "deleteLectureFromClass"]),
    handleClose() {
      const vm = this;
      vm.exceptionDialogVisible = false;
      vm.$notify({
        title: "학생 등록 완료",
        message: "학생 등록 완료",
        type: "success",
        duration: 3000,
      });
    },
    tableEventListener(event) {
      const vm = this;
      let currentTeachingClass = vm.currentTeachingClass(vm.classId);
      currentTeachingClass.lectures = vm.lectureList.sort((a, b) => {
        return a.sequence - b.sequence;
      });
      vm.refreshCount += 1;
      // refreshCount 증가로 인하여 다시 rendering 될 때 dragend 이벤트가 등록된 table element를 다시 이벤트를 등록해줘야됨(table이 기존 element가 아닌 다른 element로 대체 되기 때문에)
      vm.$nextTick(() => {
        vm.addTableEventListener();
      });
    },
    addTableEventListener() {
      const vm = this;
      const table = document.querySelector(".el-table__body");
      if (!table) {
        return;
      }
      table.addEventListener("dragend", vm.tableEventListener);
    },
    refreshLectureList(newLectureList = []) {
      const vm = this;
      let currentTeachingClass = vm.currentTeachingClass(vm.classId);
      newLectureList.forEach((nll, index) => {
        nll.sequence = index;
        currentTeachingClass.lectures[index] = nll;
      });
      vm.newLectureList = currentTeachingClass.lectures;
    },
    async onClick(type) {
      const vm = this;
      const userId = utils.getUserIdFromJwt();
      switch (type) {
        case "BACK": {
          location.href = "javascript:history.back();";
          break;
        }
        case "INPUT_CLICK": {
          document.getElementById("student_add_input").click();
          break;
        }
        case "EVALUATION": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/evaluation`);
          break;
        }
        case "ANALYSIS": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/NNjournal`);
          break;
        }
        case "Report": {
          vm.$router.push(`/a/report/teacher/${userId}/class/${vm.classId}/`);
          break;
        }
        case "NOTICE": {
          vm.$router.push(`/a/class/${vm.classId}/NNNotice/0`);
          break;
        }
        case "Q&A": {
          vm.$router.push(`/a/class/${vm.classId}/NNboard/0`);
          break;
        }
        case "ATTEND": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/attendance`);
          break;
        }
        case "GRADING": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/grading`);
          break;
        }
        case "NNGRADING": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/NNgrading`);
          break;
        }
        case "REPORT": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/reporting`);
          break;
        }
        case "NNREPORT": {
          vm.$router.push(`/a/teacher/class/${vm.classId}/NNreporting`);
          break;
        }
        // 2021-03-18 강사 Docker ON/OFF 선택 기능
        case "DOCKERON":{
          // ON -> OFF 전환
          vm.dockerstatus = false;
          
          await classService.postChangeDockerStatus({
              classId: vm.classId,
              dockerStatus: false,
          });
          vm.$notify({
              title: vm.$t("NOTIFY.JUPYTER_STATUS"),
              message: vm.$t("NOTIFY.JUPYTER_CLOSED"),
              type: "success",
              duration: 3000,
          });
          vm.dockerstatus = false;          
          break;
        }
        case "DOCKEROFF":{
          await classService.postChangeDockerStatus({
              classId: vm.classId,
              dockerStatus: true,
          });          
          vm.$notify({
            title: vm.$t("NOTIFY.JUPYTER_STATUS"),
            message: vm.$t("NOTIFY.JUPYTER_OPEN"),
            type: "success",
            duration: 3000,
          });
          
          vm.dockerstatus = true;          
          break;
        } 
        // 2021-03-31 강사에 의한 도커 삭제
        case "DOCKERDEL": {
         
          vm.$confirm(
          vm.$t("CONFIRM.WANT_DELETE_DOCKER"),
            `${vm.scTitle || ""} ` + vm.$t("CONFIRM.DELETE"),
            {
              confirmButtonText: vm.$t("NOTE.CONFIRM"),
              cancelButtonText: vm.$t("NOTIFY.CANCEL"),
              type: "warning",
            }
          )
          .then(async () => {
            try {
              await classService.deleteDocker({
                classId: vm.classId,
              });
              vm.$notify({
                title: vm.$t("NOTIFY.DELETED"),
                message: vm.$t("NOTIFY.DEL_DOCKER"),
                type: "success",
                duration: 3000,
              });
              vm.dockercreated = false;
              vm.dockerstatus = false;
            } catch (error) {
              vm.$notify({
                title: vm.$t("NOTIFY.LEC_DEL_FAIL"),
                message: error.toString(),
                type: "error",
                duration: 3000,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t("NOTIFY.CANCELLED"),
              message: vm.$t("NOTIFY.DOCKER_DEL_CAN"),
              type: "info",
              duration: 3000,
            });
          });                    
          break;
        }
        // 2021-03-31 강사에 의한 도커 생성
        case "DOCKERCREATE": {
         
          vm.$confirm(
          vm.$t("CONFIRM.WANT_CREATE_NEW_DOCKER"),
            `${vm.scTitle || ""} ` + vm.$t("CONFIRM.CREATE"),
            {
              confirmButtonText: vm.$t("NOTE.CONFIRM"),
              cancelButtonText: vm.$t("NOTIFY.CANCEL"),
              type: "warning",
            }
          )
          .then(async () => {
            try {              
              await classService.createDocker({
                classId: vm.classId,
              });
              vm.$notify({
                title: vm.$t("NOTIFY.CREATED"),
                message: vm.$t("NOTIFY.CREATE_DOCKER"),
                type: "success",
                duration: 3000,
              });
              vm.dockercreated = true;
              vm.dockerstatus = true;
            } catch (error) {
              vm.$notify({
                title: vm.$t("NOTIFY.LEC_DEL_FAIL"),
                message: error.toString(),
                type: "error",
                duration: 3000,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t("NOTIFY.CANCELLED"),
              message: vm.$t("NOTIFY.DOCKER_DEL_CAN"),
              type: "info",
              duration: 3000,
            });
          });     
          break;
        }
        case "ADD_LC_SEQUENCE": {
          vm.lectureList.forEach((item, index) => {
            lectureService.putLecture({
              lecture_id: item.lecture_id,
              sequence: index + 1,
            });
          });
          this.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.STR_ORDER_LEC"),
            type: "success",
          });
          break;
        }
        case "ADD_STUDENT": {
          const targetFile = document.getElementById("student_add_input").files[0];
          const reader = new FileReader();
          vm.exceptList = [];

          // 파일이 읽혀 졌으면 event listener 등록
          reader.onload = (event) => {
            // excel 파일 추출
            const excelDatas = reader.result
              .split("\n")
              .filter(
                (item) =>
                  item.split(",")[0] !== "" &&
                  item.split(",")[1] !== "" &&
                  item.split(",")[0] !== "이메일"
              );
            const emails = excelDatas.map((data) => data.split(",")[0]);
            const names = excelDatas.map((data) => data.split(",")[1]);
            let promiseToDo = [];
            let promiseToDo2 = [];
            // 학생 이메일이 이미 존재하는지 확인
            emails.forEach(async (email) => {
              promiseToDo.push(userService.searchUserByEmail({ email }));
            });

            Promise.all(promiseToDo).then((result) => {
              promiseToDo = [];
              // 강의 등록 명단에 추가
              result.forEach((userData) => {
                if (userData.data.length > 0) {
                  promiseToDo2.push(
                    classService.postClassUserByTeacher({
                      classId: vm.classId,
                      userId: userData.data[0].user_id,
                    })
                  );
                } else {
                  const email = userData.request.responseURL.split("email=")[1];
                  const name = excelDatas
                    .filter((item) => item.includes(email))[0]
                    .split("\r")[0]
                    .split('"')
                    .join("")
                    .split(",")
                    .slice(1)
                    .filter((item) => item !== "")
                    .join(",");
                  const password = "test";
                  // 이메일 32자 초과하는것 제외
                  if (email.length <= 32) {
                    // 회원가입
                    promiseToDo.push(
                      authService.register({
                        input: {
                          email_id: email,
                          password,
                          name,
                        },
                      })
                    );
                  } else {
                    vm.exceptList.push({
                      email,
                      name,
                    });
                  }
                }
              });

              // 회원가입이 됬으면 강의 수강 등록
              Promise.all(promiseToDo).then((result1) => {
                // 강의 등록 명단에 추가
                result1.forEach((userData) => {
                  promiseToDo2.push(
                    classService.postClassUserByTeacher({
                      classId: vm.classId,
                      userId: userData.data.user_id,
                    })
                  );
                });
                Promise.all(promiseToDo2).then((result2) => {
                  if (vm.exceptList.length > 0) {
                    vm.exceptionDialogVisible = true;
                  } else {
                    vm.$notify({
                      title: "학생 등록 완료",
                      message: "학생 등록 완료",
                      type: "success",
                      duration: 3000,
                    });
                  }
                });
              });
            });
          };
          // 파일 읽는 부분
          reader.readAsText(targetFile, "euc-kr");
          // 파일 내용 초기화
          document.getElementById("student_add_input").value = "";
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    tableColumnColor({ row, rowIndex }) {
      const now = Date.now();
      const nowTime = new Date(now);
      if (["[유인]", 0].includes(row.type)) {
        return "background: #F8EFFB";
      } else {
        if (nowTime < new Date(row.start_time)) {
          return "background: #FBFBEF";
        } else if (
          new Date(row.start_time) <= nowTime &&
          nowTime <= new Date(row.end_time)
        ) {
          return "background: #EFFBEF";
        } else {
          return "background: #EFF5FB";
        }
      }
    },
    upLecture(index) {
      const vm = this;
      if (index !== 0) {
        // 위치 바꾸기
        const tmpLecture = vm.lectureList[index - 1];
        vm.lectureList.splice(index - 1, 1);
        vm.lectureList.splice(index, 0, tmpLecture);
      }
    },
    downLecture(index) {
      const vm = this;
      if (index !== vm.lectureList.length - 1) {
        // 위치 바꾸기
        const tmpLecture = vm.lectureList[index];
        vm.lectureList.splice(index, 1);
        vm.lectureList.splice(index + 1, 0, tmpLecture);
      }
    },
    onClickLecture(row, _, column) {
      if (column.label === "-") {
        return;
      }
      const vm = this;
      vm.$router.push(`/a/teacher/NNclass/${row.class_id}`);
    },
    onClickDelete(index) {
      const vm = this;
      vm.$confirm(
        vm.$t("CONFIRM.WANT_DELETE_LEC"),
        `${vm.scTitle || ""} ` + vm.$t("CONFIRM.DELETE"),
        {
          confirmButtonText: vm.$t("NOTE.CONFIRM"),
          cancelButtonText: vm.$t("NOTIFY.CANCEL"),
          type: "warning",
        }
      )
        .then(async () => {
          try {
            const currentClass = vm.teachingClassList.find(
              (item) => item.class_id === vm.classId
            );
            const targetLecture = currentClass.lectures[index];
            await lectureService.deleteLecture({
              lectureId: targetLecture.lecture_id,
            });
            vm.$notify({
              title: vm.$t("NOTIFY.DELETED"),
              message: vm.$t("NOTIFY.DEL_LEC"),
              type: "success",
              duration: 3000,
            });
            await vm.getClass({
              type: "TEACHER",
              classId: vm.classId,
            });
            vm.refreshLectureList();
          } catch (error) {
            vm.$notify({
              title: vm.$t("NOTIFY.LEC_DEL_FAIL"),
              message: error.toString(),
              type: "error",
              duration: 3000,
            });
          }
        })
        .catch(() => {
          vm.$notify({
            title: vm.$t("NOTIFY.CANCELLED"),
            message: vm.$t("NOTIFY.LEC_DEL_CAN"),
            type: "info",
            duration: 3000,
          });
        });
    },
    onClickActivaite(index) {
      const vm = this;
      vm.$confirm(
        vm.$t("TEACHER_CLASS.ACTIV_N_OR_Y"),
        vm.$t("TEACHER_CLASS.SESSION_CONNECTION"),
        {
          confirmButtonText: vm.$t("TEACHER_CLASS.YES"),
          cancelButtonText: vm.$t("TEACHER_CLASS.NO"),
          type: "warning",
        }
      )
        .then(async () => {
          const res1 = await classService.getClass({
            id: vm.classId,
          });
          const res2 = await lectureService.putConnectSession({
            classId: vm.classId,
            lectureId: res1.data.lectures[index].lecture_id,
            isActive: 1,
          });
          vm.$notify({
            title: vm.$t("TEACHER_CLASS.SESSION_CONNECTION"),
            message: vm.$t("TEACHER_CLASS.SUCS_CONNECT_SESSION"),
            duration: 3000,
            type: "success",
          });
        })
        .catch((err) => {
          vm.$notify({
            title: vm.$t("TEACHER_CLASS.SESSION_CONNECTION"),
            message: vm.$t("TEACHER_CLASS.CANCEL_CONNECT_SESSION"),
            duration: 3000,
            type: "warning",
          });
        });
    },
  },
};
</script>

<style lang="scss" scoped>
#teacher_lecture_index_wrapper {
  .page-title {
    float: left;
    width: 400px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top: 40px;
    margin-left: 12px;
    margin-bottom: 25px;
  }

  .right-align-margin-bottom-15 {
    float: right;
    display: block;
    text-align: center;
    margin-top: 40px;
    margin-bottom: 25px;
  }

  .right-align {
    text-align: right;
  }
  .center-align {
    text-align: center;
  }
  .right-align-btn {
    width: 100%;
    height: 40px;
    border-radius: 3px;
    border: solid 1px #1989fa;
  }
  .right-align-btn-layer {
    width: 94px;
    height: 12px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
    margin-left: auto;
    margin-right: auto;
  }

  .el-btn {
    min-width: 120px;
    height: 40px;
    border-radius: 3px;
    background-color: #ffffff;
    border: solid 1px #1989fa;

    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #1989fa;
  }

  .el-btn:hover {
    min-width: 120px;
    height: 40px;
    border-radius: 3px;
    background-color: #1989fa;
    border: solid 1px #1989fa;

    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
  }

  .el-btn-phone {
    display: none;
  }

  .right-align-btn-phone {
    display: none;
  }
}

#letureList {
  display: flex;
  width: 100%;
}
#topLabel {
  display: flex;
  justify-content: space-between;
  align-items: center;
}
.top-label-btns-column {
  display: flex;
  justify-content: space-between;
}
.top-label-btn {
  font-size: 14px !important;
  padding: 12px 16px !important;
  margin: 12px !important;
  background: #4366ac !important;
  color: #fff !important;
}
.data-table .table-button {
  padding: 10px;
  border-color: #4366ac !important;
  color: #4366ac !important;
}

/* MyRoomCommonStyle.css */
nav {
  min-width: 250px;
}
#labelName {
  display: flex;
}
.selected-lecture {
  opacity: 40%;
}
section {
  min-width: 800px;
  width: 100%;
  margin: 35px 15px 0 25px;
}
section > div {
  padding-top: 10px;
}
#topLabel {
  width: initial;
  display: flex;
  justify-content: space-between;
  align-items: center;
}

/* main.css */
body {
  margin: 0px;
}
nav {
  float: left;
  width: 250px;
  height: 100%;
  background: #4366ac;
  color: #fff;
}
#logo {
  padding: 20px 0 20px 0;
  text-align: center;
}
#logo > p {
  font-size: 25px;
  font-weight: bold;
  font-family: "Roboto", sans-serif;
}
#profile {
  padding: 20px;
}
#profile1 img {
  float: left;
  margin: 5px;
}
#profile1 > p {
  margin: 5px 0 5px 0;
}
#profile2 {
  text-align: right;
}
#profile2 > p {
  text-decoration: underline;
}
#profile2 p:nth-child(1) {
  float: left;
  margin: 0;
}
#navList {
  list-style: none;
  margin: 0;
}
#navList img {
  vertical-align: middle;
}
section {
  float: left;
}
</style>
